//+------------------------------------------------------------------+
//|                                   ADXcrosses_true_with_sound.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link "http://www.metaquotes.net"
 
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_width1 1
#property indicator_width2 1
//---- input parameters
extern bool Sound = true;
extern int  ADXcrossesPeriod = 14;
//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
//----
double b4plusdi, b4minusdi, nowplusdi, nowminusdi, nShift;
datetime uplast=0;
datetime dnlast=0;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
    SetIndexStyle(0, DRAW_ARROW);
    SetIndexArrow(0, 233);
    SetIndexBuffer(0, ExtMapBuffer1);
//----
    SetIndexStyle(1, DRAW_ARROW);
    SetIndexArrow(1, 234);
    SetIndexBuffer(1, ExtMapBuffer2);
//---- name for DataWindow and indicator subwindow label
    IndicatorShortName("ADXcrosses(" + ADXcrossesPeriod + ")");
    SetIndexLabel(0, "ADXcrUp");
    SetIndexLabel(1, "ADXcrDn"); 
//----
    return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
    int limit;
    int counted_bars = IndicatorCounted();
//---- check for possible errors
    if(counted_bars < 0) 
        return(-1);
//---- last counted bar will be recounted
    if(counted_bars > 0) 
        counted_bars--;
    limit = Bars - counted_bars;
//----
    for(int i = 0; i < limit; i++)
      {
        b4plusdi = iADX(NULL, 0, ADXcrossesPeriod, PRICE_CLOSE, 
                        MODE_PLUSDI, i);
        nowplusdi = iADX(NULL, 0, ADXcrossesPeriod, PRICE_CLOSE, 
                         MODE_PLUSDI, i + 1);
        b4minusdi = iADX(NULL, 0, ADXcrossesPeriod, PRICE_CLOSE, 
                         MODE_MINUSDI, i);
        nowminusdi = iADX(NULL, 0, ADXcrossesPeriod, PRICE_CLOSE, 
                          MODE_MINUSDI, i + 1);
        nShift = iATR(NULL,0,100,i)*0.5;
        
        ExtMapBuffer1[i] = 0.0; ExtMapBuffer2[i] = 0.0;
        //----
        if(b4plusdi > b4minusdi && nowplusdi < nowminusdi)
            ExtMapBuffer1[i] = Low[i] - nShift;
        //----
        if(b4plusdi < b4minusdi && nowplusdi > nowminusdi)
            ExtMapBuffer2[i] = High[i] + nShift;
      }
//---- Sound
      if(ExtMapBuffer1[0]!=0.0 && Time[i]>uplast && Sound==true) 
        {
          string message;
          message =  StringConcatenate(Symbol()," ADXCrosses changed to Up.");
          Alert(message);
          PlaySound("alert.wav");
          uplast=Time[i];
        }
      if(ExtMapBuffer2[0]!=0.0 && Time[i]>dnlast && Sound==true) 
        {
          string message2;
          message2 = StringConcatenate(Symbol()," ADXCrosses changed to Down.");
          Alert(message2);
          PlaySound("alert.wav");
          dnlast=Time[i];
        }
//----
    return(0);
  }
//+------------------------------------------------------------------+